博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
TOJ4505: KOSARE
阅读量:5967 次
发布时间:2019-06-19

本文共 2210 字,大约阅读时间需要 7 分钟。

TOJ4505: KOSARE 分享至QQ空间

Time Limit(Common/Java):10000MS/30000MS     Memory Limit:65536KByte
Total Submit: 11            Accepted:3

Description

 

Mirko found N boxes with various forgotten toys at his attic. There are M different toys, numbered 1 through M, but each of those can appear multiple times across various boxes.

Mirko decided that he will choose some boxes in a way that there is at least one toy of each kind present, and throw the rest of the boxes away.
Determine the number of ways in which Mirko can do this.

 

Input

 

The first line of input contains two integers N and M (1 ≤ N ≤ 1 000 000, 1 ≤ M ≤ 20).

Each of the following N lines contains an integer Ki (0 ≤ Ki ≤ M) followed by Ki distinct integers from interval [1, M], representing the toys in that box.

 

Output

 

The first and only line of output should contain the requested number of ways modulo 1 000 000 007.

 

Sample Input

3 3

3 1 2 3
3 1 2 3
3 1 2 3

Sample Output

 7

Source

你有n个盒子,然后有m种物品。每个盒子各有K个物品,你有多少种方式拿盒子,把东西都拿完

那天我的思路就是去统计这些盒子的状态然后去容斥,显然是爆炸的

这个要用到那个集合的那个知识,n个元素的他的子集有2^n个,也就是幂集,在这个基础上枚举子集容斥就可以省掉很多步骤

来看一下这个状态压缩的道理吧 

之前做过求两个数字有相同数位的对数,那个把每个数直接变为2^digit,找到每一位的hash值,然后把每个数都减1,这样1对应1,2对应2,20对应2^19,这些数加起来是2^20-1,所以数组开到1<<20即可

每个盒子所对应的hash值知道了,我要和另一个盒子的东西看他们一样么,可以这样想,和他肯定不同的会是谁呢,就是从L开始到枚举的那个中间值(L+R)>>1,mi+i-L肯定是和i是相关的,要进行加法计算,但是我有些子集是重复的,需要枚举重新减去

#include
typedef __int64 ll;const ll MD=1e9+7;ll a[2000000];ll po(int n){ ll ans=1,b=2; while(n) { if(n&1)ans=ans*b%MD; b=b*b%MD; n>>=1; } return ans;}void la(int L,int R){ if(L+1==R) { a[L]=po(a[L]); return; } int mi=(L+R)>>1; for(int i=L; i

这个怎么省去加这个状态呢,就是提前进行一次二进制枚举

#include
typedef __int64 ll;const ll MD=1e9+7;ll a[2000000];ll po(int n){ ll ans=1,b=2; while(n) { if(n&1)ans=ans*b%MD; b=b*b%MD; n>>=1; } return ans;}void la(int L,int R){ if(L+1==R) { a[L]=po(a[L]); return; } int mi=(L+R)>>1; la(L,mi); la(mi,R); for(int i=L; i

直接位运算去统计,这个算法速度最快

#include
const int N=1<<20,MD=1e9+7;int cnt[N],B[N],n,m,ans[N],f;int main(){ scanf("%d%d",&n,&m); f=1<

 

 

 

 

转载于:https://www.cnblogs.com/BobHuang/p/8059974.html

你可能感兴趣的文章
axios 拦截 , 页面跳转, token 验证(自己摸索了一天搞出来的)
查看>>
有序的双链表
查看>>
程序员全国不同地区,微信(面试 招聘)群。
查看>>
【干货】界面控件DevExtreme视频教程大汇总!
查看>>
Java小细节
查看>>
poj - 1860 Currency Exchange
查看>>
chgrp命令
查看>>
Java集合框架GS Collections具体解释
查看>>
洛谷 P2486 BZOJ 2243 [SDOI2011]染色
查看>>
数值积分中的辛普森方法及其误差估计
查看>>
Web service (一) 原理和项目开发实战
查看>>
跑带宽度多少合适_跑步机选购跑带要多宽,你的身体早就告诉你了
查看>>
深入理解Java的接口和抽象类
查看>>
Javascript异步数据的同步处理方法
查看>>
iis6 zencart1.39 伪静态规则
查看>>
SQL Server代理(3/12):代理警报和操作员
查看>>
Linux备份ifcfg-eth0文件导致的网络故障问题
查看>>
2018年尾总结——稳中成长
查看>>
JFreeChart开发_用JFreeChart增强JSP报表的用户体验
查看>>
度量时间差
查看>>